﻿Public Class ChangedDelegates
    Inherits ChangedDelegatesBase

    Sub New(ByVal Kernel As Kernel)
        Me.Kernel = Kernel
    End Sub

    ''' <summary>
    ''' Traditional 2 state valve control: OPEN
    ''' </summary>
    ''' <param name="LogicalItem"></param>
    ''' <remarks></remarks>
    Public Sub Handler_TWOSTATE_VALVE001_OPEN(ByVal LogicalItem As LogicalItem)
        CommonAction(LogicalItem, LogicalItem.StateArray(0).Tag, New Control() {Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001}, New String() {"ValveSimple1.0_Red_BlackBorder"})
    End Sub

    ''' <summary>
    ''' Traditional 2 state valve control: CLOSE
    ''' </summary>
    ''' <param name="LogicalItem"></param>
    Public Sub Handler_TWOSTATE_VALVE001_CLOSE(ByVal LogicalItem As LogicalItem)
        CommonAction(LogicalItem, LogicalItem.StateArray(1).Tag, New Control() {Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001}, New String() {"ValveSimple1.0_Green_BlackBorder"})
    End Sub

    ''' <summary>
    ''' Traditional 2 state valve control: UNKOWN
    ''' </summary>
    ''' <param name="LogicalItem"></param>
    Public Sub Handler_TWOSTATE_VALVE001_UNKNOWN(ByVal LogicalItem As LogicalItem)
        CommonAction(LogicalItem, LogicalItem.StateArray(2).Tag, New Control() {Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001}, New String() {"ValveSimple1.0_Yellow_BlackBorder"})
    End Sub

    '----------------------------------------------------------------------------------------------------------------------------------------------------------------------
    '' 3 state valve control.  State: OPEN, MIDDLE, CLOSE, UNKNOWN

    ' ''' <summary>
    ' ''' Traditional 3 state valve control: OPEN
    ' ''' </summary>
    ' ''' <param name="LogicalItem"></param>
    'Public Sub Handler_THREESTATE_VALVE001_OPEN(ByVal LogicalItem As LogicalItem)
    '    CommonAction(LogicalItem, LogicalItem.StateArray(0).Tag, New Control() {Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001}, New String() {"ValveSimple1.0_Red_BlackBorder"})
    'End Sub

    ' ''' <summary>
    ' ''' Traditional 3 state valve control: MIDDLE
    ' ''' </summary>
    ' ''' <param name="LogicalItem"></param>
    'Public Sub Handler_THREESTATE_VALVE001_MIDDLE(ByVal LogicalItem As LogicalItem)
    '    CommonAction(LogicalItem, LogicalItem.StateArray(1).Tag, New Control() {Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001}, New String() {"ValveSimple1.0_Orange_BlackBorder"})
    'End Sub

    ' ''' <summary>
    ' ''' Traditional 3 state valve control: CLOSE
    ' ''' </summary>
    ' ''' <param name="LogicalItem"></param>
    'Public Sub Handler_THREESTATE_VALVE001_CLOSE(ByVal LogicalItem As LogicalItem)
    '    CommonAction(LogicalItem, LogicalItem.StateArray(2).Tag, New Control() {Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001}, New String() {"ValveSimple1.0_Green_BlackBorder"})
    'End Sub

    ' ''' <summary>
    ' ''' Traditional 3 state valve control: UNKNOWN
    ' ''' </summary>
    ' ''' <param name="LogicalItem"></param>
    'Public Sub Handler_THREESTATE_VALVE001_UNKNOWN(ByVal LogicalItem As LogicalItem)
    '    CommonAction(LogicalItem, LogicalItem.StateArray(3).Tag, New Control() {Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001}, New String() {"ValveSimple1.0_Yellow_BlackBorder"})
    'End Sub

    '----------------------------------------------------------------------------------------------------------------------------------------------------------------------
    ' ''' <summary>
    ' ''' Traditional 2 state valve control
    ' ''' </summary>
    ' ''' <param name="LogicalItem"></param>
    ' ''' <param name="StatusTag"></param>
    ' ''' <param name="Control"></param>
    ' ''' <param name="ApplyStyle"></param>
    'Public Sub Handler_TWOSTATE_VALVE(ByVal LogicalItem As LogicalItem, ByVal StatusTag As String, ByVal Control() As Control, ByVal ApplyStyle() As String)
    '    If LogicalItem.CurrentStatusId = 0 Then
    '        Kernel.ChangeStyle(Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001, "ValveSimple1.0_Red_BlackBorder") ' Open
    '    ElseIf LogicalItem.CurrentStatusId = 1 Then
    '        Kernel.ChangeStyle(Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001, "ValveSimple1.0_Green_BlackBorder") ' Close
    '    ElseIf LogicalItem.CurrentStatusId = 2 Then
    '        Kernel.ChangeStyle(Kernel.GetWindow(Of MainWindow)("MainWindow").Valve001, "ValveSimple1.0_Yellow_BlackBorder") ' Unknown
    '    End If

    '    If LogicalItem.PreStatusId <> CType(LogicalItem.ht(StatusTag), Integer) And LogicalItem.PreStatusId <> -1 Then
    '        Kernel.GetWindow(Of LOGMSG)("LOGMSG").AddMsg(System.DateTime.Now.ToString("yyyyMMdd HH:mm:ss ") + "[Delegates.CommonAction] " + LogicalItem.StateArray(LogicalItem.CurrentStatusId).Name + "(" + LogicalItem.StateArray(LogicalItem.CurrentStatusId).Tag + ")", True)
    '    End If
    'End Sub

End Class
